PROGRAM SB_5;

{ demonstriert einfachstes Ansprechen der SOUND-Blaster-Karte.
  Ein Motiv aus vier Tnen wird auf Kanal 1
  von verschiedenen Instrumenten ausgegeben.
  mr-soft April 1993 }

USES sbc_tp6, dos, crt;

CONST note_num : ARRAY [0..9] of BYTE = (67,64,62,69,67,64,62,60,62,64);
      InstrName : ARRAY [0..15] of STRING = ( 'Klavier 1','Pizzikato','Violine',
                  'Vibraphon','Oboe','Klarinette','Klavier 2','Glocken','Cello',
                  'Trompete','Gitarre','Posaune','Jazzgitarre','Cembalo','Flte','Marimba');
      Dauer = 200;

VAR Ton, Instrument, Laenge, Kanal : integer;

BEGIN

sbfd_init;                             { FM-Chip initialisieren            }

clrscr;
writeln('Direktes Ansprechen der SOUND-Blaster-Karte'); writeln;
writeln('Ein Motiv wird auf Kanal 1 nacheinander von '); writeln;
writeln('den 16 internen Instrumenten der SB-Karte vorgespielt'); writeln;
writeln('Beenden mit beliebiger Taste');

RANDOMIZE;

repeat
   for Kanal := 0 to 15 do
   BEGIN
    Instrument := random(15)+1;
   gotoXY(26,12); write('Instrument: ',Instrument,' ');
   gotoXY(26,14);write(InstrName[Instrument]);
   gotoXY(26,16);write('Kanal: ',Kanal,' ');
  
   sbfd_program_change(Kanal,Instrument);
      for Ton := 0 to 9 do
   
     BEGIN
        if Ton <8 then
        BEGIN
        sbfd_note_on(Kanal,note_num[Ton],100);  { Ton an (Kanal, note_num, velocity) }
        delay(Dauer);                       { Tondauer                           }
        sbfd_note_off(Kanal,note_num[Ton],100); { Ton aus (Kanal, note_num, velocity)}
        delay(Dauer);                       { kurze Pause                        }
        END else
        
        BEGIN
        Laenge := Dauer*3;
        sbfd_note_on(Kanal,note_num[Ton],100);  { Ton an (Kanal, note_num, velocity) }
        delay(Laenge);                      { Tondauer                           }
        sbfd_note_off(Kanal,note_num[Ton],100); { Ton aus (Kanal, note_num, velocity)}
        delay(Dauer);                       { kurze Pause                        }
        END;
     END;
     gotoXY(26,14);write('            ');
   END;
until keypressed;
                                       { FM-Chip zurcksetzen               }
sbfd_reset

END.