PROGRAM SB_Penta;

{ Einbindung der SBC-Unit und die weiterhin bentigten Units }
USES sbc_tp6, dos, crt;

CONST
  { Instrumente }
  inst : array[0..9] of array[0..15] of byte =
                ( ( $21,$11,$4c,$00,$f1,$f2,$63,$72,
                    $00,$00,$04,$00,$00,$00,$00,$00 ),

                  ( $a5,$b1,$d2,$80,$81,$f1,$03,$05,
                    $00,$00,$02,$00,$00,$00,$00,$00 ),

                  ( $71,$62,$1c,$05,$51,$52,$03,$13,
                    $00,$00,$0e,$00,$00,$00,$00,$00 ),

                  ( $11,$01,$8a,$40,$f1,$f1,$11,$b3,
                    $00,$00,$06,$00,$00,$00,$00,$00 ),

                  ( $21,$11,$11,$00,$a3,$c4,$43,$22,
                    $02,$00,$0d,$00,$00,$00,$00,$00 ),

                  ( $31,$a1,$1c,$80,$41,$92,$0b,$3b,
                    $00,$00,$0e,$00,$00,$00,$00,$00 ),

                  ( $71,$62,$c5,$05,$6e,$8b,$17,$0e,
                    $00,$00,$02,$00,$00,$00,$00,$00 ),

                  ( $41,$91,$83,$00,$65,$32,$05,$74,
                    $00,$00,$0a,$00,$00,$00,$00,$00 ),

                  ( $32,$16,$87,$80,$a1,$7d,$10,$33,
                    $00,$00,$08,$00,$00,$00,$00,$00 ),

                  ( $01,$13,$8d,$00,$51,$52,$53,$7c,
                    $01,$00,$0c,$00,$00,$00,$00,$00 ) );

CONST
     c=47; d=49; e=51; g=55; a=57;         { MIDI-Daten }
     c1=60; d1=62; e1=64; g1=67; a1=69;    { fr 16     }
     c2=72; d2=74; e2=76; g2=79; a2=81;    { Tne       }
     c3=84;
     Grundschlag=10000;
VAR
    Instrument : byte;
    Auswahl, hoehe : integer;

{ ----------------------------------------------------------- }
PROCEDURE ton (hoehe, laenge : integer);

     BEGIN      
        sbfd_note_on(0,hoehe,$40);
              delay (round (Grundschlag/Laenge));
        sbfd_note_off(0,hoehe,$40);
     END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv1;

VAR Wahl : integer ;

BEGIN
    Wahl := random(6);
    case Wahl of
    1 : Ton(c,2);
    2 : Ton(d,2);
    3 : Ton(e,2);
    4 : Ton(g,2);
    5 : Ton(a,2);
    6 : Ton(c1,2);
    END; { of case }
    { ton(g1,8);ton(a1,8);ton(g1,8); }
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv2;

VAR Wahl : integer ;

BEGIN
    Wahl := random(6);
    case Wahl of
    1 : Ton(c,4);
    2 : Ton(d,4);
    3 : Ton(e,4);
    4 : Ton(g,4);
    5 : Ton(a,4);
    6 : Ton(c1,4);
    END; { of case }
    { ton(g1,8);ton(a1,8);ton(g1,8); }
END;
{ ----------------------------------------------------------- }
PROCEDURE spiele;

VAR
    i,j : word;
    Instrument2 : byte;
    Anzahl,Tempo,Wert : integer;
                    
BEGIN
      RANDOMIZE;       
          instrument := random(10);
           
             sbfd_program_change(0,instrument);
    
      repeat
            instrument := random(10);
            sbfd_program_change(0,instrument);

             Motiv1;
             Motiv2;

      until keypressed;
END;

{ ------------------------------------------------------------------------ }
                           { Hauptprogramm }
BEGIN

    if GetEnvSetting = 0 then
  BEGIN

        if boolean( sbc_check_card and $0002 ) then
        BEGIN
            textcolor (14);textbackground (1);clrscr;
            gotoxy(30,2);
            write('mr soft 1993');
            gotoxy(17,6);
            write('Musikprogramme fr die SOUND BLASTER Karte');
            gotoxy(27,10);
            Write('Pentatonische Melodie');
            gotoxy(27,11);
            write('*********************');
            gotoxy(18,16);
            write('E n t s p a n n e n   S i e   s i c h . . . ');
            gotoxy(24,22);
            write ('Abbrechen mit beliebiger Taste');
            sbfd_init;
            sbfd_instrument(@inst);

            spiele;

            sbfd_reset;
            clrscr;

        END
        else
            writeln('Sound Blaster card not found or wrong I/O setting.');
       END
       else
            writeln('BLASTER environment variable not set or incomplete or invalid.');

END.
