PROGRAM Minimal_2;

{ Einbindung der SBC-Unit und die weiterhin bentigten Units }
USES sbc_tp6, crt;

CONST
  { Instrumente }
  inst : array[0..9] of array[0..15] of byte =
                ( ( $21,$11,$4c,$00,$f1,$f2,$63,$72,
                    $00,$00,$04,$00,$00,$00,$00,$00 ),

                  ( $a5,$b1,$d2,$80,$81,$f1,$03,$05,
                    $00,$00,$02,$00,$00,$00,$00,$00 ),

                  ( $71,$62,$1c,$05,$51,$52,$03,$13,
                    $00,$00,$0e,$00,$00,$00,$00,$00 ),

                  ( $11,$01,$8a,$40,$f1,$f1,$11,$b3,
                    $00,$00,$06,$00,$00,$00,$00,$00 ),

                  ( $21,$11,$11,$00,$a3,$c4,$43,$22,
                    $02,$00,$0d,$00,$00,$00,$00,$00 ),

                  ( $31,$a1,$1c,$80,$41,$92,$0b,$3b,
                    $00,$00,$0e,$00,$00,$00,$00,$00 ),

                  ( $71,$62,$c5,$05,$6e,$8b,$17,$0e,
                    $00,$00,$02,$00,$00,$00,$00,$00 ),

                  ( $41,$91,$83,$00,$65,$32,$05,$74,
                    $00,$00,$0a,$00,$00,$00,$00,$00 ),

                  ( $32,$16,$87,$80,$a1,$7d,$10,$33,
                    $00,$00,$08,$00,$00,$00,$00,$00 ),

                  ( $01,$13,$8d,$00,$51,$52,$53,$7c,
                    $01,$00,$0c,$00,$00,$00,$00,$00 ) );

CONST
     c=48; d=50; e=52; f=53; g=55; a=57; h=59;        { Frequenzen }
     c1=60; d1=62; e1=64; f1=65; g1=67; a1=69; h1=71; { fr drei   }
     c2=72; d2=74; e2=76; f2=77; g2=79; a2=81; h2=83; { Oktaven    }
     c3=84;
     Grundschlag=1000;
VAR
    Instrument : byte;
    Auswahl:integer;

{ ----------------------------------------------------------- }
PROCEDURE ton (hoehe,laenge : integer);

     BEGIN      
        sbfd_note_on(0,hoehe,125);
              delay (round (Grundschlag/Laenge));
        sbfd_note_off(0,hoehe,125);
     END;
{ ----------------------------------------------------------- }
 PROCEDURE Bass_ein;
 BEGIN
 sbfd_program_change(1,6);
      sbfd_note_on(1,c,80);        { Baton einschalten }
      sbfd_note_on(1,g,80);
 END;
{ ----------------------------------------------------------- }
 PROCEDURE Bass_aus;
 BEGIN
      sbfd_note_off(1,c,80);        { Baton ausschalten }
      sbfd_note_off(1,g,80);
 END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv1;
BEGIN
    Bass_ein;
    ton(g1,8);ton(a1,8);ton(g1,8);
    Bass_aus
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv2;
BEGIN
    Bass_ein;
    ton(c1,4);ton(e1,4);ton(g1,4);
    Bass_aus
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv3;
BEGIN
    Bass_ein;
    ton(c2,2);ton(h1,4);ton(a1,4);ton(g2,2);
    Bass_aus
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv4;
BEGIN
    Bass_ein; 
    ton(c,1);
    Bass_aus
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv5;
BEGIN
     Bass_ein;
     ton(g,2);ton(a,4);ton(g,4);
     Bass_aus
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv6;
BEGIN
     Bass_ein;
    ton(c3,8);ton(h2,8);ton(a2,8);ton(g2,8);
    Bass_aus
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv7;
BEGIN
     Bass_ein;
    delay(Grundschlag);
    Bass_aus
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv8;
BEGIN
     Bass_ein;
    ton(d,16);ton(e,16);ton(f,16);ton(g,16);ton(a,4);
    Bass_aus
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv9;
BEGIN
    Bass_ein;
    ton(h1,4);ton(g1,16);ton(h1,16);ton(d2,4);
    Bass_aus
END;
{ ----------------------------------------------------------- }
PROCEDURE  Einleitung;
BEGIN
   Motiv7;  Motiv7;
   Motiv7;  Motiv7
END;
{ ----------------------------------------------------------- }
PROCEDURE Ende;
BEGIN
    
    ton(c1,2);ton(d1,4);ton(c1,4);ton(d1,4);ton(c1,4);
    ton(d1,8);ton(c1,8);ton(d1,8);ton(c1,8);
    ton(d1,8);ton(c1,8);ton(d1,8);ton(c1,8);
    Bass_ein;
    ton(c1,2);ton(a,4);ton(g,4);ton(c,1);delay(100);
    ton(c,1);delay(100);ton(c,1);
    Bass_aus
END;
{ ----------------------------------------------------------- }
PROCEDURE spiele;

VAR
    i,j : word;
    Instrument, Note1,Note2 : byte;
    Anzahl,Tempo,Wert,wie_oft : integer;
                    
BEGIN
      RANDOMIZE;
     
          instrument := random(10);
            gotoxy(28,14);
            write('Instrument: ',instrument);
             sbfd_program_change(0,instrument);

             
             Einleitung;
      repeat
            instrument := random(9)+1;
            Auswahl := random (8)+1;
            wie_oft := random (23)+1;
                 

            gotoxy(22,14);
            write('Instrument: ',instrument,' - ','Motiv: ',Auswahl,' - ',wie_oft,' mal');
            gotoxy(40,22);

             sbfd_program_change(0,instrument);
            
            case Auswahl of
                 1 : for Anzahl := 1 to random( wie_oft) do Motiv1;
                 2 : for Anzahl := 1 to random( wie_oft) do Motiv2;
                 3 : for Anzahl := 1 to random( wie_oft) do Motiv3;
                 4 : for Anzahl := 1 to random( wie_oft) do Motiv4;
                 5 : for Anzahl := 1 to random( wie_oft) do Motiv5;
                 6 : for Anzahl := 1 to random( wie_oft) do Motiv6;
                 7 : for Anzahl := 1 to random( wie_oft) do Motiv7;
                 8 : for Anzahl := 1 to random( wie_oft) do Motiv8;
                 9 : for Anzahl := 1 to random( wie_oft) do Motiv9;
                 END; { of case }
           gotoxy(22,14);
            write('                                     ');
            
      until keypressed;
      gotoxy(24,18);
            write ('----------  E N D E  ----------');
      Ende;
END;

{ ------------------------------------------------------------------------ }
                           { Hauptprogramm }
BEGIN

    if GetEnvSetting = 0 then
  BEGIN

        if boolean( sbc_check_card and $0002 ) then
        BEGIN
            textcolor (14);textbackground (1);clrscr;
            gotoxy(30,2);
            write('mr soft 1993');
            gotoxy(17,6);
            write('Musikprogramme fr die SOUND BLASTER Karte');
            gotoxy(25,10);
            Write('M I N I M A L - M U S I K');
            gotoxy(25,11);
            write('*************************');
            gotoxy(24,18);
            write ('Abbrechen mit beliebiger Taste');
            sbfd_init;
            sbfd_instrument(@inst);

            spiele;
            

            sbfd_reset;
            clrscr;

        END
        else
            writeln('Sound Blaster card not found or wrong I/O setting.');
       END
       else
            writeln('BLASTER environment variable not set or incomplete or invalid.');

END.
