PROGRAM Ostinato;

{ Einbindung der SBC-Unit und die weiterhin bentigten Units }
USES sbc_tp6, crt;

CONST
  { Instrumente }
  inst : array[0..9] of array[0..15] of byte =
                ( ( $21,$11,$4c,$00,$f1,$f2,$63,$72,
                    $00,$00,$04,$00,$00,$00,$00,$00 ),

                  ( $a5,$b1,$d2,$80,$81,$f1,$03,$05,
                    $00,$00,$02,$00,$00,$00,$00,$00 ),

                  ( $71,$62,$1c,$05,$51,$52,$03,$13,
                    $00,$00,$0e,$00,$00,$00,$00,$00 ),

                  ( $11,$01,$8a,$40,$f1,$f1,$11,$b3,
                    $00,$00,$06,$00,$00,$00,$00,$00 ),

                  ( $21,$11,$11,$00,$a3,$c4,$43,$22,
                    $02,$00,$0d,$00,$00,$00,$00,$00 ),

                  ( $31,$a1,$1c,$80,$41,$92,$0b,$3b,
                    $00,$00,$0e,$00,$00,$00,$00,$00 ),

                  ( $71,$62,$c5,$05,$6e,$8b,$17,$0e,
                    $00,$00,$02,$00,$00,$00,$00,$00 ),

                  ( $41,$91,$83,$00,$65,$32,$05,$74,
                    $00,$00,$0a,$00,$00,$00,$00,$00 ),

                  ( $32,$16,$87,$80,$a1,$7d,$10,$33,
                    $00,$00,$08,$00,$00,$00,$00,$00 ),

                  ( $01,$13,$8d,$00,$51,$52,$53,$7c,
                    $01,$00,$0c,$00,$00,$00,$00,$00 ) );

CONST
     cc=48; dd=50; ee=52; ff=53; gg=55; aa=57; hh=59;
     c=48; d=50; e=52; f=53; g=55; a=57; h=59;        { Frequenzen }
     c1=60; d1=62; e1=64; f1=65; g1=67; a1=69; h1=71; { fr drei   }
     c2=72; d2=74; e2=76; f2=77; g2=79; a2=81; h2=83; { Oktaven    }
     c3=84;
     Grundschlag=3000;
VAR
    Instrument : byte;
    Auswahl:integer;

{ ----------------------------------------------------------- }
PROCEDURE ton (hoehe,laenge : integer);

     BEGIN      
        sbfd_note_on(0,hoehe,125);
              delay (round (Grundschlag/Laenge));
        sbfd_note_off(0,hoehe,125);
     END;
{ ----------------------------------------------------------- }
 PROCEDURE Bass_ein (Bass : integer);
 BEGIN
 sbfd_program_change(1,6);
      sbfd_note_on(1,Bass,80);        { Baton einschalten }
END;
{ ----------------------------------------------------------- }
 PROCEDURE Bass_aus (Bass : integer);
 BEGIN
      sbfd_note_off(1,Bass,80);        { Baton ausschalten }
 END;
{ ----------------------------------------------------------- }
{----------------------------------------------------------- }
 PROCEDURE Motiv_A1;
BEGIN
    Bass_ein(c);
    ton(c2,4);ton(g1,4);
    Bass_aus(c)
END;   
{ ----------------------------------------------------------- }
PROCEDURE Motiv_A2;
BEGIN
    Bass_ein(aa);
    ton(c2,4);ton(e2,4);
    Bass_aus(aa)
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv_A3;
BEGIN
    Bass_ein(ff);
    ton(d2,4);ton(a1,4);
    Bass_aus(ff)
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv_A4;
BEGIN
    Bass_ein(gg); 
    ton(h1,8);ton(a1,8);ton(g1,4);
    Bass_aus(gg)
END;
{ ----------------------------------------------------------- }
 PROCEDURE Motiv_B1;
BEGIN
    Bass_ein(c);
    ton(e1,8);ton(g1,8);ton(h1,8);ton(c2,8);
    Bass_aus(c)
END;   
{ ----------------------------------------------------------- }
PROCEDURE Motiv_B2;
BEGIN
    Bass_ein(aa);
    ton(e2,8);ton(a1,8);ton(h1,8);ton(c2,8);
    Bass_aus(aa)
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv_B3;
BEGIN
    Bass_ein(ff);
    ton(d2,8);ton(f2,8);ton(e2,8);ton(d2,8);
    Bass_aus(ff)
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv_B4;
BEGIN
    Bass_ein(gg); 
    ton(c2,8);ton(h1,4);ton(a1,8);
    Bass_aus(gg)
END;
{ ----------------------------------------------------------- }
 PROCEDURE Motiv_C1;
BEGIN
    Bass_ein(c);
    ton(c2,4);ton(e2,4);
    Bass_aus(c)
END;   
{ ----------------------------------------------------------- }
PROCEDURE Motiv_C2;
BEGIN
    Bass_ein(aa);
    ton(e2,4);ton(d2,4);
    Bass_aus(aa)
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv_C3;
BEGIN
    Bass_ein(ff);
    ton(f2,4);ton(e2,4);
    Bass_aus(ff)
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv_C4;
BEGIN
    Bass_ein(gg); 
    ton(e2,4);ton(a1,8);ton(h1,8);
    Bass_aus(gg)
END;
{ ----------------------------------------------------------- }
 PROCEDURE Motiv_D1;
BEGIN
    Bass_ein(c);
    ton(c1,6);ton(d1,12);ton(e1,6);ton(f1,12);
    Bass_aus(c)
END;   
{ ----------------------------------------------------------- }
PROCEDURE Motiv_D2;
BEGIN
    Bass_ein(aa);
    ton(g1,6);ton(a1,12);ton(h1,6);ton(c2,12);
    Bass_aus(aa)
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv_D3;
BEGIN
    Bass_ein(ff);
    ton(d2,6);ton(a1,12);ton(h1,6);ton(c2,12);
    Bass_aus(ff)
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv_D4;
BEGIN
    Bass_ein(gg); 
    ton(d2,8);ton(f2,4);ton(d2,8);
    Bass_aus(gg)
END;
{ ----------------------------------------------------------- }
 PROCEDURE Motiv_E1;
BEGIN
    Bass_ein(c);
    ton(e2,8);ton(c2,8);ton(g1,8);ton(e1,8);
    Bass_aus(c)
END;   
{ ----------------------------------------------------------- }
PROCEDURE Motiv_E2;
BEGIN
    Bass_ein(aa);
    ton(c2,8);ton(a1,8);ton(e1,8);ton(c1,8);
    Bass_aus(aa)
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv_E3;
BEGIN
    Bass_ein(ff);
    ton(d1,8);ton(f1,8);ton(a1,8);ton(c2,8);
    Bass_aus(ff)
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv_E4;
BEGIN
    Bass_ein(gg); 
    ton(h1,8);ton(a1,8);ton(d2,8);ton(g1,8);
    Bass_aus(gg)
END;
{ ----------------------------------------------------------- }
 PROCEDURE Motiv_F1;
BEGIN
    Bass_ein(c);
    ton(c3,16);ton(h2,16);ton(a2,4);ton(g2,16);ton(f2,16);
    Bass_aus(c)
END;   
{ ----------------------------------------------------------- }
PROCEDURE Motiv_F2;
BEGIN
    Bass_ein(aa);
    ton(e2,16);ton(d2,16);ton(c2,4);ton(h1,8);
    Bass_aus(aa)
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv_F3;
BEGIN
    Bass_ein(ff);
    ton(a1,8);ton(h1,8);ton(c2,8);ton(a1,8);
    Bass_aus(ff)
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv_F4;
BEGIN
    Bass_ein(gg); 
    ton(d2,8);ton(d2,4);ton(e2,16);ton(d2,16);
    Bass_aus(gg)
END;
{ ----------------------------------------------------------- }
 PROCEDURE Motiv_G1;
BEGIN
    Bass_ein(c);
    ton(g2,8);ton(a2,4);ton(g2,8);
    Bass_aus(c)
END;   
{ ----------------------------------------------------------- }
PROCEDURE Motiv_G2;
BEGIN
    Bass_ein(aa);
    ton(a2,8);ton(g2,4);ton(a2,16);ton(g2,16);
    Bass_aus(aa)
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv_G3;
BEGIN
    Bass_ein(ff);
    ton(a2,8);ton(g2,4);ton(a2,8);
    Bass_aus(ff)
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv_G4;
BEGIN
    Bass_ein(gg); 
    ton(h2,3);ton(g2,8);
    Bass_aus(gg)
END;
{ ----------------------------------------------------------- }
 PROCEDURE Motiv_H1;
BEGIN
    Bass_ein(c);
    ton(e2,16);ton(d2,16);ton(e2,16);ton(d2,16);
    ton(c2,16);ton(d2,16);ton(e2,16);ton(d2,16);
    Bass_aus(c)
END;   
{ ----------------------------------------------------------- }
PROCEDURE Motiv_H2;
BEGIN
    Bass_ein(aa);
    ton(e2,16);ton(c2,16);ton(d2,16);ton(e2,16);
    ton(f2,16);ton(e2,16);ton(f2,16);ton(e2,16);
    Bass_aus(aa)
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv_H3;
BEGIN
    Bass_ein(ff);
    ton(f2,16);ton(a2,16);ton(g2,16);ton(f2,16);
    ton(e2,16);ton(d2,16);ton(e2,16);ton(f2,16);
    Bass_aus(ff)
END;
{ ----------------------------------------------------------- }
PROCEDURE Motiv_H4;
BEGIN
    Bass_ein(gg);
    ton(d2,16);ton(h2,16);ton(a2,16);ton(g2,16);
    ton(f2,16);ton(e2,16);ton(f2,16);ton(d2,16);
    Bass_aus(gg)
END;
{ ----------------------------------------------------------- }
{ ----------------------------------------------------------- }
PROCEDURE Variation_1;
BEGIN
Motiv_A1;Motiv_A2;Motiv_A3;Motiv_A4;
END;
{ ----------------------------------------------------------- }
PROCEDURE Variation_2;
BEGIN
           Motiv_B1;Motiv_B2;Motiv_B3;Motiv_B4;
END;
{ ----------------------------------------------------------- }
PROCEDURE Variation_3;
BEGIN
           Motiv_C1;Motiv_C2;Motiv_C3;Motiv_C4;
END;
{ ----------------------------------------------------------- }
PROCEDURE Variation_4;
BEGIN
           Motiv_D1;Motiv_D2;Motiv_D3;Motiv_D4;
END;
{ ----------------------------------------------------------- }
PROCEDURE Variation_5;
BEGIN
           Motiv_E1;Motiv_E2;Motiv_E3;Motiv_E4;
END;
{ ----------------------------------------------------------- }
PROCEDURE Variation_6;
BEGIN
           Motiv_F1;Motiv_F2;Motiv_F3;Motiv_F4;
END;
{ ----------------------------------------------------------- }
PROCEDURE Variation_7;
BEGIN
           Motiv_G1;Motiv_G2;Motiv_G3;Motiv_G4;
END;
{ ----------------------------------------------------------- }
PROCEDURE Variation_8;
BEGIN
           Motiv_H1;Motiv_H2;Motiv_H3;Motiv_H4;
END;
{ ----------------------------------------------------------- }
PROCEDURE spiele;

VAR
    i,j : word;
    Instrument, Note1,Note2 : byte;
    Anzahl,Tempo,Wert,wie_oft : integer;
                    
BEGIN
      RANDOMIZE;
     
          instrument := random(10);
            gotoxy(28,14);
            write('Instrument: ',instrument);
             sbfd_program_change(0,instrument);

             Variation_1;
             Variation_2;
             Variation_3;
             Variation_4;
             Variation_5;
             Variation_6;
             Variation_7;
             Variation_8;

           
           {  Einleitung;  }
      repeat
            instrument := random(9)+1;
            Auswahl := random (8)+1;
            wie_oft := random (23)+1;
                 

         {   gotoxy(22,14);
            write('Instrument: ',instrument,' - ','Motiv: ',Auswahl,' - ',wie_oft,' mal');
            gotoxy(40,22);   }

             sbfd_program_change(0,instrument);
            
            case Auswahl of
                 1 : Variation_1;
                 2 : Variation_2;
                 3 : Variation_3;
                 4 : Variation_4;
                 5 : Variation_5;
                 6 : Variation_6;
                 7 : Variation_7;
                 8 : Variation_8;
                 END; { of case }
           gotoxy(22,14);
            write('                                     ');
            
       until keypressed;
      gotoxy(24,18);
            write ('----------  E N D E  ----------');
END;

{ ------------------------------------------------------------------------ }
                           { Hauptprogramm }
BEGIN

    if GetEnvSetting = 0 then
  BEGIN

        if boolean( sbc_check_card and $0002 ) then
        BEGIN
            textcolor (14);textbackground (1);clrscr;
            gotoxy(30,2);
            write('mr soft 1993');
            gotoxy(17,6);
            write('Musikprogramme fr die SOUND BLASTER Karte');
            gotoxy(25,10);
            Write('B A S S O   O S T I N A T O ');
            gotoxy(25,11);
            write('***************************');
            gotoxy(24,18);
            write ('Abbrechen mit beliebiger Taste');
            sbfd_init;
            sbfd_instrument(@inst);

            spiele;
            

            sbfd_reset;
            clrscr;

        END
        else
            writeln('Sound Blaster card not found or wrong I/O setting.');
       END
       else
            writeln('BLASTER environment variable not set or incomplete or invalid.');

END.
